'use strict';

var _jsLogger = require('js-logger');

var _jsLogger2 = _interopRequireDefault(_jsLogger);

var _observable = require('./lib/observable');

var _observable2 = _interopRequireDefault(_observable);

var _index = require('./index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_jsLogger2.default.useDefaults({
    defaultLevel: _jsLogger2.default.DEBUG,
    formatter: function formatter(messages, context) {
        var date = new Date(),
            year = date.getFullYear(),
            month = ("0" + (date.getMonth() + 1)).substr(-2),
            day = ("0" + date.getDate()).substr(-2),
            hour = ("0" + date.getHours()).substr(-2),
            minute = ("0" + date.getMinutes()).substr(-2),
            second = ("0" + date.getSeconds()).substr(-2),
            millis = ("000" + date.getMilliseconds()).substr(-3),
            level = ("     " + context.level.name).substr(-5);

        messages.unshift('[' + year + '/' + month + '/' + day + ']' + ('[' + hour + ':' + minute + ':' + second + '.' + millis + ']') + ('[' + level + ']'));
    }
}); // uncomment if you've installed rxjs
// import 'any-observable/register/rxjs-all';

_index.SenseME.on('founddevice', function (dev) {
    _jsLogger2.default.debug('Found a device: ' + dev.name + ' (' + dev.ip + ')');
}).on('lostdevice', function (dev) {
    _jsLogger2.default.debug('Lost a device: ' + dev.name + ' (' + dev.ip + ')');
}).discover();