'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _accessorVisitor = require('./walk/accessorVisitor');

var _walk = require('./walk');

var _walk2 = _interopRequireDefault(_walk);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createAccessors(accessors) {
    (0, _walk2.default)(_accessorVisitor.accessorGenerators, [createAccessorVisitor], {
        controller: this,
        accessors: accessors
    });
}

function createAccessorVisitor(name, props, node, context) {
    var _context$path = context.path;
    var path = _context$path === undefined ? [] : _context$path;
    var controller = context.controller;
    var accessors = context.accessors;


    if (name) {
        var base = void 0;
        if (node.isComputed) {
            base = controller[node.baseName];
        }

        if (name !== 'value') {
            Object.defineProperty(controller, name, {
                writable: false,
                enumerable: true,
                value: {}
            });

            controller = controller[name];
        }

        if (typeof node === 'function' || node.isComputed) {
            var functions = void 0,
                value = void 0;

            if (node.isComputed) {
                var _node$func = node.func(base);

                functions = _node$func.functions;
                value = _node$func.value;
            } else {
                var _node = node(accessors);

                functions = _node.functions;
                value = _node.value;
            }

            Object.defineProperties(controller, functions);

            Object.defineProperty(controller, 'value', value);
        }
    }

    return _extends({}, context, { controller: controller });
}

exports.default = createAccessors;