'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.method = exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var FlatMapObserver = function () {
    function FlatMapObserver(subscriber, mapper) {
        _classCallCheck(this, FlatMapObserver);

        this.mapper = mapper;
        this.subscriber = subscriber;

        this._index = 0;
        this._subs = [];
    }

    _createClass(FlatMapObserver, [{
        key: 'next',
        value: function next(item) {
            var _this = this;

            var subscriber = this.subscriber;
            if (subscriber.closed) {
                this._subs.forEach(function (x) {
                    return x.unsubscribe();
                });
                return;
            }

            var inner = void 0;
            try {
                inner = this.mapper(item, this._index++);
            } catch (e) {
                this.error(e);
                return;
            }

            if (inner) {
                (function () {
                    var sub = inner.subscribe(function (x) {
                        if (subscriber.closed) {
                            _this._subs.forEach(function (x) {
                                return x.unsubscribe();
                            });
                        } else {
                            subscriber.next(x);
                        }
                    }, subscriber.error.bind(subscriber), function () {
                        _this._subs.remove(sub);
                        _this._closeIfReady();
                    });

                    _this._subs.push(sub);
                })();
            }
        }
    }, {
        key: 'error',
        value: function error() {
            var _subscriber;

            (_subscriber = this.subscriber).error.apply(_subscriber, arguments);
        }
    }, {
        key: 'complete',
        value: function complete() {
            this._outerFinished = true;
            this._closeIfReady();
        }
    }, {
        key: '_closeIfReady',
        value: function _closeIfReady() {
            if (this._outerFinished && this._subs.length === 0) {
                this.subscriber.complete();
            }
        }
    }]);

    return FlatMapObserver;
}();

function flatMapObservable(observable, mapper) {
    return new _index2.default(function (subscriber) {
        return observable.subscribe(new FlatMapObserver(subscriber, mapper));
    });
}

function method(mapper) {
    return flatMapObservable(this, mapper);
}

exports.default = flatMapObservable;
exports.method = method;