'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.method = exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MapObserver = function () {
    function MapObserver(subscriber, mapper) {
        _classCallCheck(this, MapObserver);

        this.mapper = mapper;
        this.subscriber = subscriber;

        this._index = 0;
    }

    _createClass(MapObserver, [{
        key: 'next',
        value: function next(item) {
            if (this.subscriber.closed) {
                return;
            }

            try {
                this.subscriber.next(this.mapper(item, this._index++));
            } catch (e) {
                this.error(e);
            }
        }
    }, {
        key: 'error',
        value: function error() {
            var _subscriber;

            (_subscriber = this.subscriber).error.apply(_subscriber, arguments);
        }
    }, {
        key: 'complete',
        value: function complete() {
            var _subscriber2;

            (_subscriber2 = this.subscriber).complete.apply(_subscriber2, arguments);
        }
    }]);

    return MapObserver;
}();

function mapObservable(observable, mapper) {
    return new _index2.default(function (subscriber) {
        return observable.subscribe(new MapObserver(subscriber, mapper));
    });
}

function method(mapper) {
    return mapObservable(this, mapper);
}

exports.default = mapObservable;
exports.method = method;