'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var DERIVED_PLACHOLDER = '$$derived';
function calculatePathsVisitor(name, props, node, context) {
    var parentPath = context.parentPath || [];
    if (props.isDerived) {
        parentPath = parentPath.concat([DERIVED_PLACHOLDER]);
    }
    if (name) {
        parentPath = parentPath.concat(name);
    }

    var parentFriendlyPath = context.parentFriendlyPath || [];
    if (props.friendlyName) {
        parentFriendlyPath = parentFriendlyPath.concat(props.friendlyName);
    }

    var calculatedPaths = {};
    if (props.type && props.type !== 'group') {
        var setCmd = [].concat(props.type === 'power' ? [] : ["SET"]);

        if (parentPath.includes(DERIVED_PLACHOLDER)) {
            calculatedPaths = {
                getPath: parentPath.filter(function (x) {
                    return x !== DERIVED_PLACHOLDER;
                }).concat(props.valuePath || []),
                setPath: parentPath.map(function (x) {
                    return x === DERIVED_PLACHOLDER ? 'SET' : x;
                }).concat(props.setPath || []),
                refreshPath: parentPath.map(function (x) {
                    return x === DERIVED_PLACHOLDER ? 'GET' : x;
                }).concat(props.valuePath || [])
            };
        } else {
            calculatedPaths = {
                getPath: parentPath.concat(props.valuePath || []),
                setPath: parentPath.concat(setCmd).concat(props.setPath || []),
                refreshPath: parentPath.concat(['GET']).concat(props.valuePath || [])
            };
        }

        calculatedPaths.friendlyPath = parentFriendlyPath;

        if (!props.settable) {
            delete calculatedPaths.setPath;
        }
    }

    return _extends({}, context, { parentPath: parentPath, parentFriendlyPath: parentFriendlyPath, calculatedPaths: calculatedPaths });
}

exports.default = calculatePathsVisitor;