'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.loadCommands = exports.default = undefined;

var _calculatePathsVisitor = require('./calculatePathsVisitor');

var _calculatePathsVisitor2 = _interopRequireDefault(_calculatePathsVisitor);

var _accessorVisitor = require('./accessorVisitor');

var _accessorVisitor2 = _interopRequireDefault(_accessorVisitor);

var _pathMappingVisitor = require('./pathMappingVisitor');

var _pathMappingVisitor2 = _interopRequireDefault(_pathMappingVisitor);

var _specVisitor = require('./specVisitor');

var _specVisitor2 = _interopRequireDefault(_specVisitor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function processNode(name, node, visitors) {
    var context = arguments.length <= 3 || arguments[3] === undefined ? {} : arguments[3];

    // Pull out metadata
    var meta = node.meta;

    var nodes = _objectWithoutProperties(node, ['meta']);

    // run the visitors


    var newContext = context;
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = [].concat(visitors)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var visitor = _step.value;

            newContext = visitor(name || "", meta, node, newContext);
        }

        // if there's more subnodes, process them
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    Object.keys(nodes).forEach(function (k) {
        processNode(k, nodes[k], visitors, newContext);
    });
}

function walk(object, visitors) {
    var context = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];

    processNode("", object, visitors, context);
}

function loadCommands() {
    walk(require('../../commands.json'), [_calculatePathsVisitor2.default, _pathMappingVisitor2.default, _specVisitor2.default, _accessorVisitor2.default]);
}

exports.default = walk;
exports.loadCommands = loadCommands;