'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var realPathToFriendlyPath = {};
var friendlyPathToRealPath = {};

function pathMappingVisitor(name, props, node, context) {
    var _context$calculatedPa = context.calculatedPaths;
    var getPath = _context$calculatedPa.getPath;
    var friendlyPath = _context$calculatedPa.friendlyPath;


    if (props.type !== undefined && props.type !== 'group') {
        var realPath = getPath.join(';');
        var propFriendlyPath = friendlyPath.join(';');

        friendlyPathToRealPath[propFriendlyPath] = realPath;
        realPathToFriendlyPath[realPath] = propFriendlyPath;
    }

    return context;
}

exports.default = pathMappingVisitor;
exports.realPathToFriendlyPath = realPathToFriendlyPath;
exports.friendlyPathToRealPath = friendlyPathToRealPath;